SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;


CREATE TABLE `backup_cmpl` (
  `id` int(10) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `idprod` int(15) UNSIGNED NOT NULL,
  `name` mediumtext COLLATE utf8_bin NOT NULL,
  `prot` float NOT NULL,
  `fat` float NOT NULL,
  `carb` float NOT NULL,
  `gi` tinyint(3) UNSIGNED NOT NULL,
  `weight` float NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_diary` (
  `id` int(10) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `time` mediumtext COLLATE utf8_bin NOT NULL,
  `comm` text COLLATE utf8_bin,
  `sh1` float DEFAULT NULL,
  `sh2` float DEFAULT NULL,
  `k1` float DEFAULT NULL,
  `k2` float DEFAULT NULL,
  `k3` float DEFAULT NULL,
  `dose` float DEFAULT NULL,
  `prot` float DEFAULT NULL,
  `fat` float DEFAULT NULL,
  `carb` float DEFAULT NULL,
  `gi` tinyint(3) UNSIGNED DEFAULT NULL,
  `weight` float DEFAULT NULL,
  `type` smallint(6) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_diaryrecords` (
  `id` int(10) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `name` mediumtext COLLATE utf8_bin,
  `prot` float DEFAULT NULL,
  `fat` float DEFAULT NULL,
  `carb` float DEFAULT NULL,
  `gi` tinyint(3) UNSIGNED DEFAULT NULL,
  `weight` float DEFAULT NULL,
  `issnack` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `owner` int(10) UNSIGNED NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_groups` (
  `id` int(10) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `name` mediumtext COLLATE utf8_bin NOT NULL,
  `sortind` mediumint(8) UNSIGNED NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_menus` (
  `id` int(15) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `name` mediumtext COLLATE utf8_bin NOT NULL,
  `prot` float NOT NULL,
  `fat` float NOT NULL,
  `carb` float NOT NULL,
  `gi` tinyint(3) UNSIGNED NOT NULL,
  `weight` float NOT NULL,
  `issnack` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `idorig` int(15) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_prods` (
  `id` int(15) UNSIGNED NOT NULL,
  `iduser` int(10) UNSIGNED NOT NULL,
  `idgroup` int(10) UNSIGNED NOT NULL,
  `name` mediumtext CHARACTER SET utf8 NOT NULL,
  `prot` float NOT NULL,
  `fat` float NOT NULL,
  `carb` float NOT NULL,
  `gi` tinyint(3) UNSIGNED NOT NULL,
  `weight` float NOT NULL,
  `cmpl` tinyint(1) UNSIGNED NOT NULL DEFAULT '0',
  `usage` mediumint(8) UNSIGNED NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `backup_users` (
  `id` int(10) UNSIGNED NOT NULL,
  `login` varchar(20) COLLATE utf8_bin NOT NULL,
  `pass` varchar(255) COLLATE utf8_bin NOT NULL,
  `email` varchar(100) COLLATE utf8_bin NOT NULL,
  `lastuse` int(11) UNSIGNED NOT NULL,
  `k1` float DEFAULT NULL,
  `k2` float DEFAULT NULL,
  `k3` float DEFAULT NULL,
  `sh1` float DEFAULT NULL,
  `sh2` float DEFAULT NULL,
  `be` tinyint(3) NOT NULL DEFAULT '10',
  `eaten` int(11) NOT NULL DEFAULT '0',
  `eatendate` date NOT NULL DEFAULT '1970-01-01'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `coefs` (
  `id` int(10) NOT NULL,
  `iduser` int(10) NOT NULL,
  `time` varchar(5) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '00:00',
  `k1` float DEFAULT NULL,
  `k2` float DEFAULT NULL,
  `k3` float DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `diary` (
  `id` int(14) NOT NULL,
  `iduser` int(14) NOT NULL,
  `dt` datetime NOT NULL,
  `rem` text NOT NULL,
  `type` tinyint(1) NOT NULL DEFAULT '1',
  `sh1` float DEFAULT NULL,
  `sh2` float DEFAULT NULL,
  `k1` float DEFAULT NULL,
  `k2` float DEFAULT NULL,
  `k3` float DEFAULT NULL,
  `prot` float DEFAULT NULL,
  `fat` float DEFAULT NULL,
  `carb` float DEFAULT NULL,
  `gi` tinyint(3) DEFAULT NULL,
  `weight` float DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `diaryrecords` (
  `id` int(14) NOT NULL,
  `iduser` int(14) NOT NULL,
  `owner` int(14) NOT NULL,
  `name` text NOT NULL,
  `prot` float NOT NULL,
  `fat` float NOT NULL,
  `carb` float NOT NULL,
  `gi` tinyint(3) NOT NULL,
  `weight` float NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `session` (
  `code_sess` varchar(30) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `id_user` int(5) NOT NULL,
  `user_agent_sess` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL,
  `lastuse` int(11) NOT NULL,
  `mobile` tinyint(1) DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE `settings` (
  `id` int(15) UNSIGNED NOT NULL,
  `iduser` int(15) NOT NULL,
  `menuinfo` smallint(3) NOT NULL DEFAULT '152',
  `roundto` smallint(3) NOT NULL DEFAULT '0',
  `shwhole` tinyint(1) NOT NULL DEFAULT '0',
  `mmol` tinyint(1) NOT NULL DEFAULT '1',
  `shtarget` float NOT NULL DEFAULT '5.6',
  `usefreq` tinyint(1) NOT NULL DEFAULT '1',
  `freqcount` smallint(4) NOT NULL DEFAULT '15',
  `filteroff` smallint(3) NOT NULL DEFAULT '25',
  `k3factor` float NOT NULL DEFAULT '187',
  `weight` float NOT NULL DEFAULT '60',
  `timedcoefs` tinyint(1) NOT NULL DEFAULT '0',
  `calorlimit` int(10) UNSIGNED NOT NULL DEFAULT '2000',
  `shlow` float NOT NULL DEFAULT '3.2',
  `shhigh` float NOT NULL DEFAULT '8',
  `period` int(11) NOT NULL DEFAULT '7'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


ALTER TABLE `backup_cmpl`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_diary`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_diaryrecords`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_groups`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_menus`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_prods`
  ADD PRIMARY KEY (`id`),
  ADD KEY `iduser` (`iduser`);

ALTER TABLE `backup_users`
  ADD PRIMARY KEY (`id`),
  ADD KEY `login` (`login`,`pass`);

ALTER TABLE `coefs`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `diary`
  ADD PRIMARY KEY (`id`,`dt`,`iduser`);

ALTER TABLE `diaryrecords`
  ADD PRIMARY KEY (`id`,`iduser`,`owner`);

ALTER TABLE `session`
  ADD PRIMARY KEY (`code_sess`),
  ADD KEY `code_sess` (`id_user`,`code_sess`,`user_agent_sess`);

ALTER TABLE `settings`
  ADD PRIMARY KEY (`id`,`iduser`);


ALTER TABLE `backup_cmpl`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5000898;
ALTER TABLE `backup_diary`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=15284;
ALTER TABLE `backup_diaryrecords`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=436562;
ALTER TABLE `backup_groups`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=268351;
ALTER TABLE `backup_menus`
  MODIFY `id` int(15) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=128295;
ALTER TABLE `backup_prods`
  MODIFY `id` int(15) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=7667757;
ALTER TABLE `backup_users`
  MODIFY `id` int(10) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1149;
ALTER TABLE `coefs`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=5;
ALTER TABLE `diary`
  MODIFY `id` int(14) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=78;
ALTER TABLE `diaryrecords`
  MODIFY `id` int(14) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=57;
ALTER TABLE `settings`
  MODIFY `id` int(15) UNSIGNED NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=110;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
